searchData={"content_type":"text/markdown","items":[{"doc":"To use this module, simply call `generate_key/2`\nto generated an ordered key `c` that sorts \nlexicographically in between `a` and `b`, two ordered keys you'll provided as arguments.","ref":"ZenoIndexingEx.html","title":"ZenoIndexingEx","type":"module"},{"doc":"# iex> ZenoIndexingEx.generate_key(nil, nil)\n    # {:ok, \"a0\"}\n    #\n    #\n    # iex> ZenoIndexingEx.generate_key(\"a0\", nil)\n    # {:ok, \"a1\"}\n\nAnd if you'd like to use it without having to pattern match the result\n    \n    # iex> ZenoIndexingEx.generate_key!(nil, nil)\n    # \"a0\"\n    #\n    # iex> ZenoIndexingEx.generate_key!(\"a0\", nil)\n    # \"a1\"","ref":"ZenoIndexingEx.html#module-examples","title":"Examples - ZenoIndexingEx","type":"module"},{"doc":"Ordered keys (or *order keys* for short) are not just any strings (see `t:order_key()`), \n  they are a concatenation of a two components: \n\n1. An *integer component*, i.e. a stringified integer\n2. An optional *fractional component*, a stringified fractional value\n\nThis order key format was first explained in Greenspan's notebook, specifically,\nhis approach to _fractional indexing algorithm with logarithmic key growth_. \nIn layman's terms, this order key format was designed to slow down the growth \nof  keys as keys are inserted in and around existing keys.","ref":"ZenoIndexingEx.html#module-order-key-format","title":"Order key format - ZenoIndexingEx","type":"module"},{"doc":"Explain and define the format of the integer component and the \noptional fractional component.","ref":"ZenoIndexingEx.html#module-todo-integer-component","title":"TODO Integer component - ZenoIndexingEx","type":"module"},{"doc":"","ref":"ZenoIndexingEx.html#module-todo-fractional-component","title":"TODO Fractional component - ZenoIndexingEx","type":"module"},{"doc":"Generates an order key (i.e. a key that sorts lexicographically) in \nbetween the keys `a` and `b`.","ref":"ZenoIndexingEx.html#generate_key/2","title":"ZenoIndexingEx.generate_key/2","type":"function"},{"doc":"Generates an order key just like `generate_key/2`, but raises an error if the key generation fails.","ref":"ZenoIndexingEx.html#generate_key!/2","title":"ZenoIndexingEx.generate_key!/2","type":"function"},{"doc":"","ref":"ZenoIndexingEx.html#t:order_key/0","title":"ZenoIndexingEx.order_key/0","type":"type"}],"producer":{"name":"ex_doc","version":"0.37.1"},"proglang":"elixir"}